diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/windowed-filter.h ns-3.34/src/internet/model/windowed-filter.h
--- ns-3.33/src/internet/model/windowed-filter.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/internet/model/windowed-filter.h	2021-07-14 10:31:06.000000000 -0700
@@ -0,0 +1,299 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ *  Copyright (c) 2016 The Chromium Authors. All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are
+ * met:
+ *
+ *    * Redistributions of source code must retain the above copyright
+ * notice, this list of conditions and the following disclaimer.
+ *    * Redistributions in binary form must reproduce the above
+ * copyright notice, this list of conditions and the following disclaimer
+ * in the documentation and/or other materials provided with the
+ * distribution.
+ *    * Neither the name of Google Inc. nor the names of its
+ * contributors may be used to endorse or promote products derived from
+ * this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+ * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/*
+ *  Note: This code is modified to work under ns-3's environment.
+ *  Modified by: Vivek Jain <jain.vivek.anand@gmail.com>
+ *               Viyom Mittal <viyommittal@gmail.com>
+ *               Mohit P. Tahiliani <tahiliani@nitk.edu.in>
+ */
+
+// Implements Kathleen Nichols' algorithm for tracking the minimum (or maximum)
+// estimate of a stream of samples over some fixed time interval. (E.g.,
+// the minimum RTT over the past five minutes.) The algorithm keeps track of
+// the best, second best, and third best min (or max) estimates, maintaining an
+// invariant that the measurement time of the n'th best >= n-1'th best.
+// The algorithm works as follows. On a reset, all three estimates are set to
+// the same sample. The second best estimate is then recorded in the second
+// quarter of the window, and a third best estimate is recorded in the second
+// half of the window, bounding the worst case error when the true min is
+// monotonically increasing (or true max is monotonically decreasing) over the
+// window.
+//
+// A new best sample replaces all three estimates, since the new best is lower
+// (or higher) than everything else in the window and it is the most recent.
+// The window thus effectively gets reset on every new min. The same property
+// holds true for second best and third best estimates. Specifically, when a
+// sample arrives that is better than the second best but not better than the
+// best, it replaces the second and third best estimates but not the best
+// estimate. Similarly, a sample that is better than the third best estimate
+// but not the other estimates replaces only the third best estimate.
+//
+// Finally, when the best expires, it is replaced by the second best, which in
+// turn is replaced by the third best. The newest sample replaces the third
+// best.
+
+#ifndef WINDOWED_FILTER_H_
+#define WINDOWED_FILTER_H_
+
+namespace ns3 {
+/**
+ * \brief Compares two values
+ * \param T  type of the measurement that is being filtered.
+ */
+template <class T>
+struct MinFilter
+{
+public:
+  /**
+   * \brief Compares two values
+   *
+   * \param lhs left hand value
+   * \param rhs right hand value
+   * \return returns true if the first is less than or equal to the second.
+   */
+  bool operator() (const T& lhs, const T& rhs) const
+  {
+    if (rhs == 0 || lhs == 0)
+      {
+        return false;
+      }
+    return lhs <= rhs;
+  }
+};
+/**
+ * \brief Compares two values
+ * \param T  type of the measurement that is being filtered.
+ */
+template <class T>
+struct MaxFilter
+{
+public:
+  /**
+   * \brief Compares two values
+   *
+   * \param lhs left hand value
+   * \param rhs right hand value
+   * \return returns true if the first is greater than or equal to the second.
+   */
+  bool operator() (const T& lhs, const T& rhs) const
+  {
+    if (rhs == 0 || lhs == 0)
+      {
+        return false;
+      }
+    return lhs >= rhs;
+  }
+};
+/**
+ * \brief Construct a windowed filter
+ *
+ * Use the following to construct a windowed filter object of type T.
+ * For example, a min filter using QuicTime as the time type:
+ *      WindowedFilter<T, MinFilter<T>, QuicTime, QuicTime::Delta> ObjectName;
+ * max filter using 64-bit integers as the time type:
+ *      WindowedFilter<T, MaxFilter<T>, uint64_t, int64_t> ObjectName;
+ *
+ * \param T -- type of the measurement that is being filtered.
+ * \param Compare -- MinFilter<T> or MaxFilter<T>, depending on the type of filter desired.
+ * \param TimeT -- the type used to represent timestamps.
+ * \param TimeDeltaT -- the type used to represent continuous time intervals between
+ * two timestamps.  Has to be the type of (a - b) if both |a| and |b| are
+ * of type TimeT.
+ */
+template <class T, class Compare, typename TimeT, typename TimeDeltaT>
+class WindowedFilter
+{
+public:
+  /**
+   * \brief contructor
+   */
+  WindowedFilter ()
+  {
+  }
+
+  /**
+   * \brief contructor
+   * \param windowLength is the period after which a best estimate expires.
+   * \param zeroValue is used as the uninitialized value for objects of T. Importantly,
+   * zeroValue should be an invalid value for a true sample.
+   * \param zeroTime is the time of instance record time.
+   */
+  WindowedFilter (TimeDeltaT windowLength, T zeroValue, TimeT zeroTime)
+    : m_windowLength (windowLength),
+      m_zeroValue (zeroValue),
+      m_samples
+  {
+    Sample (m_zeroValue, zeroTime),
+    Sample (m_zeroValue, zeroTime),
+    Sample (m_zeroValue, zeroTime)
+  } {}
+  /**
+   * \brief Changes the window length.  Does not update any current samples.
+   * \param windowLength is the period after which a best estimate expires.
+   */
+  void SetWindowLength (TimeDeltaT windowLength)
+  {
+    m_windowLength = windowLength;
+  }
+  /**
+   * \brief Updates best estimates with |sample|, and expires and updates best
+   * estimates as necessary.
+   *
+   * \param new_sample update new sample.
+   * \param new_time record time of the new sample.
+   */
+  void Update (T new_sample, TimeT new_time)
+  {
+    // Reset all estimates if they have not yet been initialized, if new sample
+    // is a new best, or if the newest recorded estimate is too old.
+    if (m_samples[0].sample == m_zeroValue
+        || Compare () (new_sample, m_samples[0].sample)
+        || new_time - m_samples[2].time > m_windowLength)
+      {
+        Reset (new_sample, new_time);
+        return;
+      }
+    if (Compare () (new_sample, m_samples[1].sample))
+      {
+        m_samples[1] = Sample (new_sample, new_time);
+        m_samples[2] = m_samples[1];
+      }
+    else if (Compare () (new_sample, m_samples[2].sample))
+      {
+        m_samples[2] = Sample (new_sample, new_time);
+      }
+    // Expire and update estimates as necessary.
+    if (new_time - m_samples[0].time > m_windowLength)
+      {
+        // The best estimate hasn't been updated for an entire window, so promote
+        // second and third best estimates.
+        m_samples[0] = m_samples[1];
+        m_samples[1] = m_samples[2];
+        m_samples[2] = Sample (new_sample, new_time);
+        // Need to iterate one more time. Check if the new best estimate is
+        // outside the window as well, since it may also have been recorded a
+        // long time ago. Don't need to iterate once more since we cover that
+        // case at the beginning of the method.
+        if (new_time - m_samples[0].time > m_windowLength)
+          {
+            m_samples[0] = m_samples[1];
+            m_samples[1] = m_samples[2];
+          }
+        return;
+      }
+    if (m_samples[1].sample == m_samples[0].sample
+        && new_time - m_samples[1].time > m_windowLength >> 2)
+      {
+        // A quarter of the window has passed without a better sample, so the
+        // second-best estimate is taken from the second quarter of the window.
+        m_samples[2] = m_samples[1] = Sample (new_sample, new_time);
+        return;
+      }
+    if (m_samples[2].sample == m_samples[1].sample
+        && new_time - m_samples[2].time > m_windowLength >> 1)
+      {
+        // We've passed a half of the window without a better estimate, so take
+        // a third-best estimate from the second half of the window.
+        m_samples[2] = Sample (new_sample, new_time);
+      }
+  }
+
+  /**
+   * \brief Resets all estimates to new sample.
+   * \param new_sample update new sample.
+   * \param new_time record time of the new sample.
+   */
+  void Reset (T new_sample, TimeT new_time)
+  {
+    m_samples[0] = m_samples[1] = m_samples[2] = Sample (new_sample, new_time);
+  }
+
+  /**
+   * \brief Returns Max/Min value so far among the windowed samples.
+   * \return returns Best (max/min) value so far among the windowed samples.
+   */
+  T GetBest () const
+  {
+    return m_samples[0].sample;
+  }
+
+  /**
+   * \brief Returns second Max/Min value so far among the windowed samples.
+   * \return returns second Best (max/min) value so far among the windowed samples.
+   */
+  T GetSecondBest () const
+  {
+    return m_samples[1].sample;
+  }
+
+  /**
+   * \brief Returns third Max/Min value so far among the windowed samples.
+   * \return returns third Best (max/min) value so far among the windowed samples.
+   */
+  T GetThirdBest () const
+  {
+    return m_samples[2].sample;
+  }
+
+  /**
+   * \brief sample.
+   */
+  struct Sample
+  {
+    T sample; //!< recorded sample.
+    TimeT time; //!< time when the sample was recorded.
+    /**
+     * \brief constructor
+     */
+    Sample ()
+    {
+    }
+
+    /**
+     * \brief constructor
+     * \param init_sample value of sample.
+     * \param init_time time when the sample was recorded..
+     */
+    Sample (T init_sample, TimeT init_time)
+      : sample (init_sample),
+        time (init_time)
+    {
+    }
+  };
+
+  TimeDeltaT m_windowLength;    //!< Time length of window.
+  T          m_zeroValue;       //!< Uninitialized value of T.
+  Sample     m_samples[3];      //!< Best estimate is element 0.
+};
+
+}  // namespace ns3
+#endif  // WINDOWED_FILTER_H_
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/test/icmp-test.cc ns-3.34/src/internet/test/icmp-test.cc
--- ns-3.33/src/internet/test/icmp-test.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/test/icmp-test.cc	2021-07-14 10:31:06.000000000 -0700
@@ -100,13 +100,21 @@
   IcmpEchoReplyTestCase ();
   virtual ~IcmpEchoReplyTestCase ();
 
+  /**
+   * Send data
+   * \param socket output socket
+   * \param dst destination address
+   */
   void SendData (Ptr<Socket> socket, Ipv4Address dst);
-  void DoSendData (Ptr<Socket> socket, Ipv4Address dst);
+  /**
+   * Receive data
+   * \param socket input socket
+   */
   void ReceivePkt (Ptr<Socket> socket);
 
 private:
   virtual void DoRun (void);
-  Ptr<Packet> m_receivedPacket;
+  Ptr<Packet> m_receivedPacket; //!< received packet
 
 };
 
@@ -125,7 +133,7 @@
 
 
 void
-IcmpEchoReplyTestCase::DoSendData (Ptr<Socket> socket, Ipv4Address dst)
+IcmpEchoReplyTestCase::SendData (Ptr<Socket> socket, Ipv4Address dst)
 {
   Ptr<Packet> p = Create<Packet> ();
   Icmpv4Echo echo;
@@ -147,15 +155,6 @@
 
 
 void
-IcmpEchoReplyTestCase::SendData (Ptr<Socket> socket, Ipv4Address dst)
-{
-  m_receivedPacket = Create<Packet> ();
-  Simulator::ScheduleWithContext (socket->GetNode ()->GetId (), Seconds (0),
-                                  &IcmpEchoReplyTestCase::DoSendData, this, socket, dst);
-  Simulator::Run ();
-}
-
-void
 IcmpEchoReplyTestCase::ReceivePkt (Ptr <Socket> socket)
 {
   Address from;
@@ -210,7 +209,9 @@
 
   // Set a TTL big enough
   socket->SetIpTtl (1);
-  SendData (socket, i.GetAddress (1,0));
+  Simulator::ScheduleWithContext (socket->GetNode ()->GetId (), Seconds (0),
+                                  &IcmpEchoReplyTestCase::SendData, this, socket, i.GetAddress (1,0));
+  Simulator::Run ();
 
   NS_TEST_EXPECT_MSG_EQ (m_receivedPacket->GetSize (), 28, " Unexpected ICMPV4_ECHO_REPLY packet size");
 
@@ -231,13 +232,21 @@
   IcmpTimeExceedTestCase ();
   virtual ~IcmpTimeExceedTestCase ();
 
+  /**
+   * Send data
+   * \param socket output socket
+   * \param dst destination address
+   */
   void SendData (Ptr<Socket> socket, Ipv4Address dst);
-  void DoSendData (Ptr<Socket> socket, Ipv4Address dst);
+  /**
+   * Receive data
+   * \param socket input socket
+   */
   void ReceivePkt (Ptr<Socket> socket);
 
 private:
   virtual void DoRun (void);
-  Ptr<Packet> m_receivedPacket;
+  Ptr<Packet> m_receivedPacket; //!< received packet
 
 };
 
@@ -256,7 +265,7 @@
 
 
 void
-IcmpTimeExceedTestCase::DoSendData (Ptr<Socket> socket, Ipv4Address dst)
+IcmpTimeExceedTestCase::SendData (Ptr<Socket> socket, Ipv4Address dst)
 {
   Ptr<Packet> p = Create<Packet> ();
   Icmpv4Echo echo;
@@ -277,16 +286,6 @@
 
 
 void
-IcmpTimeExceedTestCase::SendData (Ptr<Socket> socket, Ipv4Address dst)
-{
-  m_receivedPacket = Create<Packet> ();
-  Simulator::ScheduleWithContext (socket->GetNode ()->GetId (), Seconds (0),
-                                  &IcmpTimeExceedTestCase::DoSendData, this, socket, dst);
-  Simulator::Run ();
-}
-
-
-void
 IcmpTimeExceedTestCase::ReceivePkt (Ptr<Socket> socket)
 {
   Address from;
@@ -355,7 +354,9 @@
 
   // The ttl is not big enough , causing an ICMP Time Exceeded response
   socket->SetIpTtl (1);
-  SendData (socket, i2.GetAddress (1,0));
+  Simulator::ScheduleWithContext (socket->GetNode ()->GetId (), Seconds (0),
+                                  &IcmpTimeExceedTestCase::SendData, this, socket, i2.GetAddress (1,0));
+  Simulator::Run ();
 
   NS_TEST_EXPECT_MSG_EQ (m_receivedPacket->GetSize (), 56, " Unexpected ICMP Time Exceed Response packet size");
 
@@ -375,13 +376,21 @@
   IcmpV6EchoReplyTestCase ();
   virtual ~IcmpV6EchoReplyTestCase ();
 
+  /**
+   * Send data
+   * \param socket output socket
+   * \param dst destination address
+   */
   void SendData (Ptr<Socket> socket, Ipv6Address dst);
-  void DoSendData (Ptr<Socket> socket, Ipv6Address dst);
+  /**
+   * Receive data
+   * \param socket input socket
+   */
   void ReceivePkt (Ptr<Socket> socket);
 
 private:
   virtual void DoRun (void);
-  Ptr<Packet> m_receivedPacket;
+  Ptr<Packet> m_receivedPacket; //!< received packet
 
 };
 
@@ -400,7 +409,7 @@
 
 
 void
-IcmpV6EchoReplyTestCase::DoSendData (Ptr<Socket> socket, Ipv6Address dst)
+IcmpV6EchoReplyTestCase::SendData (Ptr<Socket> socket, Ipv6Address dst)
 {
   Ptr<Packet> p = Create<Packet> ();
   Icmpv6Echo echo (1);
@@ -422,15 +431,6 @@
 
 
 void
-IcmpV6EchoReplyTestCase::SendData (Ptr<Socket> socket, Ipv6Address dst)
-{
-  m_receivedPacket = Create<Packet> ();
-  Simulator::ScheduleWithContext (socket->GetNode ()->GetId (), Seconds (0),
-                                  &IcmpV6EchoReplyTestCase::DoSendData, this, socket, dst);
-  Simulator::Run ();
-}
-
-void
 IcmpV6EchoReplyTestCase::ReceivePkt (Ptr <Socket> socket)
 {
   Address from;
@@ -498,7 +498,9 @@
   // Set a TTL big enough
   socket->SetIpTtl (1);
 
-  SendData (socket, i.GetAddress (1,1));
+  Simulator::ScheduleWithContext (socket->GetNode ()->GetId (), Seconds (0),
+                                  &IcmpV6EchoReplyTestCase::SendData, this, socket, i.GetAddress (1,1));
+  Simulator::Run ();
 
   NS_TEST_EXPECT_MSG_EQ (m_receivedPacket->GetSize (), 72, " Unexpected ICMPV6_ECHO_REPLY packet size");
 
@@ -518,13 +520,21 @@
   IcmpV6TimeExceedTestCase ();
   virtual ~IcmpV6TimeExceedTestCase ();
 
+  /**
+   * Send data
+   * \param socket output socket
+   * \param dst destination address
+   */
   void SendData (Ptr<Socket> socket, Ipv6Address dst);
-  void DoSendData (Ptr<Socket> socket, Ipv6Address dst);
+  /**
+   * Receive data
+   * \param socket input socket
+   */
   void ReceivePkt (Ptr<Socket> socket);
 
 private:
   virtual void DoRun (void);
-  Ptr<Packet> m_receivedPacket;
+  Ptr<Packet> m_receivedPacket; //!< received packet
 
 };
 
@@ -543,7 +553,7 @@
 
 
 void
-IcmpV6TimeExceedTestCase::DoSendData (Ptr<Socket> socket, Ipv6Address dst)
+IcmpV6TimeExceedTestCase::SendData (Ptr<Socket> socket, Ipv6Address dst)
 {
   Ptr<Packet> p = Create<Packet> ();
   Icmpv6Echo echo (1);
@@ -565,15 +575,6 @@
 
 
 void
-IcmpV6TimeExceedTestCase::SendData (Ptr<Socket> socket, Ipv6Address dst)
-{
-  m_receivedPacket = Create<Packet> ();
-  Simulator::ScheduleWithContext (socket->GetNode ()->GetId (), Seconds (0),
-                                  &IcmpV6TimeExceedTestCase::DoSendData, this, socket, dst);
-  Simulator::Run ();
-}
-
-void
 IcmpV6TimeExceedTestCase::ReceivePkt (Ptr <Socket> socket)
 {
   Address from;
@@ -658,7 +659,9 @@
   // The hop limit is not big enough , causing an ICMPV6 Time Exceeded error
   socket->SetIpv6HopLimit (1);
 
-  SendData (socket, interfaces2.GetAddress (1,1));
+  Simulator::ScheduleWithContext (socket->GetNode ()->GetId (), Seconds (0),
+                                  &IcmpV6TimeExceedTestCase::SendData, this, socket, interfaces2.GetAddress (1,1));
+  Simulator::Run ();
 
   NS_TEST_EXPECT_MSG_EQ (m_receivedPacket->GetSize (), 72, " Unexpected ICMPV6_ECHO_REPLY packet size");
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/test/ipv4-deduplication-test.cc ns-3.34/src/internet/test/ipv4-deduplication-test.cc
--- ns-3.33/src/internet/test/ipv4-deduplication-test.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/test/ipv4-deduplication-test.cc	2021-07-14 10:31:06.000000000 -0700
@@ -126,19 +126,35 @@
    */
   void CheckDrops (const std::string &name);
 
-  static const Time DELAY;
+  static const Time DELAY; //!< Channel delay
+
+  /**
+   * Creates the test name according to the parameters
+   * \param enable deduplication enabled
+   * \param expire expiration delay for duplicate cache entries
+   * \returns A string describing the test
+   */
   static std::string MakeName (bool enable, Time expire);
 
+  /**
+   * Enum of test types
+   */
   enum MODE {ENABLED = 0,
              DISABLED,
              DEGENERATE};  // enabled, but expiration time too low
-  MODE m_mode;
-  Time m_expire;
-  std::map<std::string, uint32_t> m_packetCountMap;
-  std::map<std::string, uint32_t> m_dropCountMap;
+  MODE m_mode; //!< Test type
+  Time m_expire; //!< Expiration delay for duplicate cache entries
+  std::map<std::string, uint32_t> m_packetCountMap; //!< map of received packets (node name, counter)
+  std::map<std::string, uint32_t> m_dropCountMap; //!< map of received packets (node name, counter)
 
 public:
   virtual void DoRun (void);
+
+  /**
+   * Constructor
+   * \param enable deduplication enabled
+   * \param expire expiration delay for duplicate cache entries
+   */
   Ipv4DeduplicationTest (bool enable, Time expire = Seconds (1));
 
   /**
@@ -532,9 +548,16 @@
     Ipv4DeduplicationPerformanceTest (void);
     virtual void DoRun (void);
   private:
-    std::vector <Ptr<Socket> > m_sockets;
-    std::vector <uint8_t> m_txPackets;
-    uint8_t m_target;
+    std::vector <Ptr<Socket> > m_sockets; //!< sockets in use
+    std::vector <uint8_t> m_txPackets;  //!< transmitted packets for each socket
+    uint8_t m_target; //!< number of packets to transmit on each socket
+
+    /**
+     * Send data
+     * \param socket output socket
+     * \param to destination address
+     * \param socketIndex index of the socket
+     */
     void DoSendData (Ptr<Socket> socket, Address to, uint8_t socketIndex);
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/test/ipv4-fragmentation-test.cc ns-3.34/src/internet/test/ipv4-fragmentation-test.cc
--- ns-3.33/src/internet/test/ipv4-fragmentation-test.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/test/ipv4-fragmentation-test.cc	2021-07-14 10:31:06.000000000 -0700
@@ -113,6 +113,10 @@
 
 public:
   virtual void DoRun (void);
+  /**
+   * Constructor
+   * \param broadcast send broadcast packets (true) or unicast packets (false)
+   */
   Ipv4FragmentationTest (bool broadcast);
   ~Ipv4FragmentationTest ();
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/test/ipv6-ripng-test.cc ns-3.34/src/internet/test/ipv6-ripng-test.cc
--- ns-3.33/src/internet/test/ipv6-ripng-test.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/test/ipv6-ripng-test.cc	2021-07-14 10:31:06.000000000 -0700
@@ -229,7 +229,7 @@
   Ipv6AddressHelper ipv6;
 
   ipv6.SetBase (Ipv6Address ("2001:1::"), Ipv6Prefix (64));
-  Ipv6InterfaceContainer iic1 = ipv6.Assign (net1);
+  Ipv6InterfaceContainer iic1 = ipv6.AssignWithoutOnLink (net1);
   iic1.SetForwarding (1, true);
   iic1.SetDefaultRouteInAllNodes (1);
 
@@ -242,7 +242,7 @@
   iic3.SetForwarding (1, true);
 
   ipv6.SetBase (Ipv6Address ("2001:2::"), Ipv6Prefix (64));
-  Ipv6InterfaceContainer iic4 = ipv6.Assign (net4);
+  Ipv6InterfaceContainer iic4 = ipv6.AssignWithoutOnLink (net4);
   iic4.SetForwarding (0, true);
   iic4.SetDefaultRouteInAllNodes (0);
 
@@ -459,7 +459,7 @@
   Ipv6AddressHelper ipv6;
 
   ipv6.SetBase (Ipv6Address ("2001:1::"), Ipv6Prefix (64));
-  Ipv6InterfaceContainer iic1 = ipv6.Assign (net1);
+  Ipv6InterfaceContainer iic1 = ipv6.AssignWithoutOnLink (net1);
   iic1.SetForwarding (1, true);
   iic1.SetDefaultRouteInAllNodes (1);
 
@@ -472,7 +472,7 @@
   iic3.SetForwarding (1, true);
 
   ipv6.SetBase (Ipv6Address ("2001:2::"), Ipv6Prefix (64));
-  Ipv6InterfaceContainer iic4 = ipv6.Assign (net4);
+  Ipv6InterfaceContainer iic4 = ipv6.AssignWithoutOnLink (net4);
   iic4.SetForwarding (0, true);
   iic4.SetDefaultRouteInAllNodes (0);
 
@@ -653,7 +653,7 @@
   Ipv6AddressHelper ipv6;
 
   ipv6.SetBase (Ipv6Address ("2001:1::"), Ipv6Prefix (64));
-  Ipv6InterfaceContainer iic0 = ipv6.Assign (net0);
+  Ipv6InterfaceContainer iic0 = ipv6.AssignWithoutOnLink (net0);
 
   Ipv6InterfaceContainer iic1 = ipv6.AssignWithoutAddress (net1);
   iic1.SetForwarding (0, true);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/test/tcp-advertised-window-test.cc ns-3.34/src/internet/test/tcp-advertised-window-test.cc
--- ns-3.33/src/internet/test/tcp-advertised-window-test.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/test/tcp-advertised-window-test.cc	2021-07-14 10:31:06.000000000 -0700
@@ -353,6 +353,11 @@
 }
 //-----------------------------------------------------------------------------
 
+/**
+ * \ingroup internet-tests
+ * \ingroup test
+ * \brief Test the TCP's advertised window size when there is a loss of specific packets.
+ */
 class TcpAdvWindowOnLossTest : public TcpGeneralTest
 {
 public:
@@ -361,7 +366,7 @@
    * \param desc description
    * \param size segment size
    * \param packets number of packets to send
-   * \param lossRatio error ratio
+   * \param toDrop packets to be dropped
    */
   TcpAdvWindowOnLossTest (const std::string &desc, uint32_t size, uint32_t packets,
                           std::vector<uint32_t> &toDrop);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/test/tcp-bbr-test.cc ns-3.34/src/internet/test/tcp-bbr-test.cc
--- ns-3.33/src/internet/test/tcp-bbr-test.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/internet/test/tcp-bbr-test.cc	2021-07-14 10:31:06.000000000 -0700
@@ -0,0 +1,203 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2018 NITK Surathkal
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Vivek Jain <jain.vivek.anand@gmail.com>
+ *          Viyom Mittal <viyommittal@gmail.com>
+ *          Mohit P. Tahiliani <tahiliani@nitk.edu.in>
+ *
+ */
+
+#include "ns3/test.h"
+#include "ns3/log.h"
+#include "ns3/tcp-congestion-ops.h"
+#include "ns3/tcp-socket-base.h"
+#include "ns3/tcp-bbr.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("TcpBbrTestSuite");
+
+/**
+ * \brief Testing whether BBR enables pacing
+ */
+class TcpBbrPacingEnableTest : public TestCase
+{
+public:
+  /**
+   * \brief constructor
+   * \param pacing pacing configuration
+   * \param name description of the test
+   */
+  TcpBbrPacingEnableTest (bool pacing, const std::string &name);
+
+private:
+  virtual void DoRun (void);
+  /**
+   * \brief Execute the test.
+   */
+  void ExecuteTest (void);
+  bool m_pacing; //!< Initial pacing configuration.
+};
+
+TcpBbrPacingEnableTest::TcpBbrPacingEnableTest (bool pacing, const std::string &name)
+  : TestCase (name),
+    m_pacing (pacing)
+{}
+
+void
+TcpBbrPacingEnableTest::DoRun ()
+{
+  Simulator::Schedule (Seconds (0.0), &TcpBbrPacingEnableTest::ExecuteTest, this);
+  Simulator::Run ();
+  Simulator::Destroy ();
+}
+
+void
+TcpBbrPacingEnableTest::ExecuteTest ()
+{
+  Ptr<TcpSocketState> state = CreateObject <TcpSocketState> ();
+  state->m_pacing = m_pacing;
+
+  Ptr<TcpBbr> cong = CreateObject <TcpBbr> ();
+
+  cong->CongestionStateSet (state, TcpSocketState::CA_OPEN);
+
+  NS_TEST_ASSERT_MSG_EQ (state->m_pacing, true,
+                         "BBR has not updated pacing value");
+}
+
+/**
+ * \brief Tests whether BBR sets correct value of pacing and cwnd gain based on different state.
+ */
+class TcpBbrCheckGainValuesTest : public TestCase
+{
+public:
+  /**
+   * \brief constructor
+   * \param state BBR state/mode under test
+   * \param highGain value of pacing and cwnd gain
+   * \param name description of the test
+   */
+  TcpBbrCheckGainValuesTest (TcpBbr::BbrMode_t state, double highGain, const std::string &name);
+
+private:
+  virtual void DoRun (void);
+  /**
+   * \brief Execute the test.
+   */
+  void ExecuteTest (void);
+  TcpBbr::BbrMode_t m_mode; //!< BBR mode under test
+  double m_highGain;        //!< Value of BBR high gain
+};
+
+TcpBbrCheckGainValuesTest::TcpBbrCheckGainValuesTest (TcpBbr::BbrMode_t state,
+                                                      double highGain, const std::string &name)
+  : TestCase (name),
+    m_mode (state),
+    m_highGain (highGain)
+{}
+
+void
+TcpBbrCheckGainValuesTest::DoRun ()
+{
+  Simulator::Schedule (Seconds (0.0), &TcpBbrCheckGainValuesTest::ExecuteTest, this);
+  Simulator::Run ();
+  Simulator::Destroy ();
+}
+
+void
+TcpBbrCheckGainValuesTest::ExecuteTest ()
+{
+  Ptr<TcpBbr> cong = CreateObject <TcpBbr> ();
+  cong->SetAttribute ("HighGain", DoubleValue (m_highGain));
+  double actualPacingGain, actualCwndGain, desiredPacingGain = m_highGain, desiredCwndGain = m_highGain;
+  TcpBbr::BbrMode_t desiredMode = TcpBbr::BBR_STARTUP;
+  switch (m_mode)
+    {
+      case TcpBbr::BBR_STARTUP:
+        cong->EnterStartup ();
+        desiredPacingGain = m_highGain;
+        desiredCwndGain  = m_highGain;
+        actualPacingGain = cong->GetPacingGain ();
+        actualCwndGain = cong->GetCwndGain ();
+        desiredMode = TcpBbr::BBR_STARTUP;
+        break;
+      case TcpBbr::BBR_DRAIN:
+        cong->EnterDrain ();
+        desiredPacingGain = 1 / m_highGain;
+        desiredCwndGain  = m_highGain;
+        desiredMode = TcpBbr::BBR_DRAIN;
+        break;
+      case TcpBbr::BBR_PROBE_BW:
+        cong->EnterProbeBW ();
+        // The value of desiredPacingGain is sensitive to the setting of random
+        // variable stream. The value of 1.25 has been used in this test with a
+        // stream value of 4 (default for TCP BBR). Note that if the stream value
+        // is changed, this test might fail because when BBR enters the PROBE_BW
+        // phase, the value of actualPacingGain is chosen randomly from 1.25,
+        // 0.75, 1, 1, 1, 1, 1, 1.
+        desiredPacingGain = 1.25;
+        desiredCwndGain  = 2;
+        desiredMode = TcpBbr::BBR_PROBE_BW;
+        break;
+      case TcpBbr::BBR_PROBE_RTT:
+        cong->EnterProbeRTT ();
+        desiredPacingGain = 1;
+        desiredCwndGain  = 1;
+        desiredMode = TcpBbr::BBR_PROBE_RTT;
+        break;
+      default:
+        NS_ASSERT (false);
+    }
+
+  actualPacingGain = cong->GetPacingGain ();
+  actualCwndGain = cong->GetCwndGain ();
+  NS_TEST_ASSERT_MSG_EQ (m_mode, desiredMode, "BBR has not entered into desired state");
+  NS_TEST_ASSERT_MSG_EQ (actualPacingGain, desiredPacingGain, "BBR has not updated into desired pacing gain");
+  NS_TEST_ASSERT_MSG_EQ (actualCwndGain, desiredCwndGain, "BBR has not updated into desired cwnd gain");
+}
+
+/**
+ * \ingroup internet-test
+ * \ingroup tests
+ *
+ * \brief TCP BBR TestSuite
+ */
+class TcpBbrTestSuite : public TestSuite
+{
+public:
+  /**
+   * \brief constructor
+   */
+  TcpBbrTestSuite () : TestSuite ("tcp-bbr-test", UNIT)
+  {
+    AddTestCase (new TcpBbrPacingEnableTest (true, "BBR must keep pacing feature on"), TestCase::QUICK);
+
+    AddTestCase (new TcpBbrPacingEnableTest (false, "BBR must turn on pacing feature"), TestCase::QUICK);
+
+    AddTestCase (new TcpBbrCheckGainValuesTest (TcpBbr::BBR_STARTUP, 4, "BBR should enter to STARTUP phase and set cwnd and pacing gain accordingly"), TestCase::QUICK);
+
+    AddTestCase (new TcpBbrCheckGainValuesTest (TcpBbr::BBR_DRAIN, 4, "BBR should enter to DRAIN phase and set cwnd and pacing gain accordingly"), TestCase::QUICK);
+
+    AddTestCase (new TcpBbrCheckGainValuesTest (TcpBbr::BBR_PROBE_BW, 4, "BBR should enter to BBR_PROBE_BW phase and set cwnd and pacing gain accordingly"), TestCase::QUICK);
+
+    AddTestCase (new TcpBbrCheckGainValuesTest (TcpBbr::BBR_PROBE_RTT, 4, "BBR should enter to BBR_PROBE_RTT phase and set cwnd and pacing gain accordingly"), TestCase::QUICK);
+  }
+};
+
+static TcpBbrTestSuite g_tcpBbrTest; //!< static variable for test initialization
+}
